﻿Public Class Sample1

    Private Sub SetRigButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SetRigButton.Click
        Dim khz As String
        Dim msg As String
        Dim frq As Single = 0
        Dim res As Boolean = True

        If FreqTextBox.Text = String.Empty Or ModeComboBox.Text = String.Empty Then
            msg = "No Frequency or Mode Specified"
            MsgBox(msg, MsgBoxStyle.OkOnly, "Sample1Error")
            Return
        End If
        frq = Conversion.Val(FreqTextBox.Text) * 1000
        If frq = 0.0 Then
            msg = "Frequency is invalid"
            MsgBox(msg, MsgBoxStyle.OkOnly, "Sample1 Error")
            Return
        End If
        khz = frq 'Converts frq to string
        res = DDESetRig(khz, ModeComboBox.Text)
        If res = False Then
            msg = "Failed connection to Commander. Please make sure it is running and that the frequency and mode are in the correct format"
            MsgBox(msg, MsgBoxStyle.OkOnly, "Sample1 Error")
        End If

    End Sub

    Private Function DDESetRig(ByVal Freq, ByVal Mode)
        Dim ddeInst As UInt32 = 0  'The DDE conversation instance
        Dim hszService As UInt32 = 0 'DDE String handle for the service
        Dim hszTopic As UInt32 = 0 'DDE string handle for the topic
        Dim Service As String = "CI-V Commander" 'Service name
        Dim Topic As String = "DDEServer" 'Topic name
        Dim data As String = String.Empty 'Command string
        Dim lf As String = String.Empty 'Length of Freq parameter
        Dim mf As String = String.Empty 'Length of Mode parameter
        Dim htransaction As UInt32 = 0 'Result from DdeClientTransaxtion
        Dim DataLen As Int32 = 0 'Length of command data string
        Dim hconv As UInt32 = 0 'DDE conversatio handle
        Dim res As UInt32 = 0 'Captures returned results
        Dim zero As UInt32 = 0 'Dummy referred to when we to to ref a zero
        Dim success As Boolean = True 'Success or fail flag

        ' Get a conversation handle
        Win32API.User.DdeInitialize(ddeInst, zero, Win32API.User.APPCMD_CLIENTONLY, 0)
        If ddeInst = 0 Then
            success = False 'Should never happen
        End If
        'Convert the Service and Topic names to DDE string handles.
        hszService = Win32API.User.DdeCreateStringHandle(ddeInst, Service, Win32API.User.CP_WINANSI)
        hszTopic = Win32API.User.DdeCreateStringHandle(ddeInst, Topic, Win32API.User.CP_WINANSI)
        If hszService = 0 Or hszTopic = 0 Then
            success = False
        End If
        'Connect to CI-V Commander
        hconv = Win32API.User.DdeConnect(ddeInst, hszService, hszTopic, zero)
        If hconv = 0 Then
            success = False 'Will happen if Commander doesn't accept the connection
        End If

        lf = Len(Freq).ToString 'Lngth of Freq
        mf = Len(Mode).ToString 'Lwngth of Mode

        data = "000xcvrfreqmode<xcvrfreq:" + lf + ">" + Freq + "<xcvrmode:" + mf + ">" + Mode
        DataLen = Len(data)
        res = Win32API.User.DdeClientTransaction(data, DataLen, hconv, 0, 0,
                Win32API.User.XTYP_EXECUTE, Win32API.User.TIMEOUT_ASYNC, htransaction)
        If res = 0 Then
            success = False
        End If
        If hconv <> 0 Then
            Win32API.User.DdeDisconnect(ddeInst)
        End If
        Return success
    End Function
End Class
